      subroutine boys_dd(m,n,iminj,icontr,inddyy,zeta,px,py,pz,pxax,
     &                   pyay,pzaz,pxbx,pyby,pzbz,base,ss,ps,ds,pp,dp,
     &                   dd,pso,dso,dpo,c,c1,c2,c3,x_moment,y_moment,
     &                   z_moment)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),icontr(*),inddyy(m,*)

      dimension zeta(*),px(*),py(*),pz(*),pxax(*),pyay(*),pzaz(*),
     &          pxbx(*),pyby(*),pzbz(*),base(*),ss(n,*),ps(n,*),ds(n,*),
     &          pp(n,*),dp(n,*),dd(n,*),pso(n,*),dso(n,*),dpo(n,*),c(*),
     &          c1(n,*),c2(n,*),c3(n,*),x_moment(*),y_moment(*),
     &          z_moment(*)

      data zero,one,thrhlf,two,three,pi/0.0d0,1.0d0,1.5d0,
     &                                  2.0d0,3.0d0,3.1415926535898d0/

      sqrt3=sqrt(three)

      do 1001 i=1,n
 1001 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1002 i=1,n
      pso(i,1)=pxax(i)*base(i)
      pso(i,2)=pyay(i)*base(i)
 1002 pso(i,3)=pzaz(i)*base(i)

      do 1003 i=1,n
 1003 c(i)=base(i)/(two*zeta(i))

      do 1004 i=1,n
      dso(i,1)=pxax(i)*pso(i,1)+c(i)
      dso(i,2)=pyay(i)*pso(i,1)
      dso(i,3)=pzaz(i)*pso(i,1)
      dso(i,4)=pyay(i)*pso(i,2)+c(i)
      dso(i,5)=pzaz(i)*pso(i,2)
 1004 dso(i,6)=pzaz(i)*pso(i,3)+c(i)

      do 1005 j=1,3
      do 1005 i=1,n
 1005 c1(i,j)=pso(i,j)/(two*zeta(i))

      do 1006 i=1,n
      dpo(i,01)=pxbx(i)*dso(i,1)+c1(i,1)+c1(i,1)
      dpo(i,02)=pyby(i)*dso(i,1)
      dpo(i,03)=pzbz(i)*dso(i,1)
      dpo(i,04)=pxbx(i)*dso(i,2)+c1(i,2)
      dpo(i,05)=pyby(i)*dso(i,2)+c1(i,1)
      dpo(i,06)=pzbz(i)*dso(i,2)
      dpo(i,07)=pxbx(i)*dso(i,3)+c1(i,3)
      dpo(i,08)=pyby(i)*dso(i,3)
      dpo(i,09)=pzbz(i)*dso(i,3)+c1(i,1)
      dpo(i,10)=pxbx(i)*dso(i,4)
      dpo(i,11)=pyby(i)*dso(i,4)+c1(i,2)+c1(i,2)
      dpo(i,12)=pzbz(i)*dso(i,4)
      dpo(i,13)=pxbx(i)*dso(i,5)
      dpo(i,14)=pyby(i)*dso(i,5)+c1(i,3)
      dpo(i,15)=pzbz(i)*dso(i,5)+c1(i,2)
      dpo(i,16)=pxbx(i)*dso(i,6)
      dpo(i,17)=pyby(i)*dso(i,6)
 1006 dpo(i,18)=pzbz(i)*dso(i,6)+c1(i,3)+c1(i,3)

      do 1007 i=1,n
      ss(i,1)=px(i)*base(i)
      ss(i,2)=py(i)*base(i)
 1007 ss(i,3)=pz(i)*base(i)

      do 1008 i=1,n
      ps(i,1)=pxax(i)*ss(i,1)+c(i)
      ps(i,2)=pxax(i)*ss(i,2)
      ps(i,3)=pxax(i)*ss(i,3)
      ps(i,4)=pyay(i)*ss(i,1)
      ps(i,5)=pyay(i)*ss(i,2)+c(i)
      ps(i,6)=pyay(i)*ss(i,3)
      ps(i,7)=pzaz(i)*ss(i,1)
      ps(i,8)=pzaz(i)*ss(i,2)
 1008 ps(i,9)=pzaz(i)*ss(i,3)+c(i)

      do 1009 j=1,3
      do 1009 i=1,n
 1009 c1(i,j)=ss(i,j)/(two*zeta(i))

      do 1010 j=1,3
      do 1010 i=1,n
 1010 c2(i,j)=pso(i,j)/(two*zeta(i))

      do 1011 i=1,n
      ds(i,01)=pxax(i)*ps(i,1)+c1(i,1)+c2(i,1)
      ds(i,02)=pxax(i)*ps(i,2)+c1(i,2)
      ds(i,03)=pxax(i)*ps(i,3)+c1(i,3)
      ds(i,04)=pyay(i)*ps(i,1)
      ds(i,05)=pyay(i)*ps(i,2)        +c2(i,1)
      ds(i,06)=pyay(i)*ps(i,3)
      ds(i,07)=pzaz(i)*ps(i,1)
      ds(i,08)=pzaz(i)*ps(i,2)
      ds(i,09)=pzaz(i)*ps(i,3)        +c2(i,1)
      ds(i,10)=pyay(i)*ps(i,4)+c1(i,1)
      ds(i,11)=pyay(i)*ps(i,5)+c1(i,2)+c2(i,2)
      ds(i,12)=pyay(i)*ps(i,6)+c1(i,3)
      ds(i,13)=pzaz(i)*ps(i,4)
      ds(i,14)=pzaz(i)*ps(i,5)
      ds(i,15)=pzaz(i)*ps(i,6)        +c2(i,2)
      ds(i,16)=pzaz(i)*ps(i,7)+c1(i,1)
      ds(i,17)=pzaz(i)*ps(i,8)+c1(i,2)
 1011 ds(i,18)=pzaz(i)*ps(i,9)+c1(i,3)+c2(i,3)

      do 1012 i=1,n
      pp(i,01)=pxbx(i)*ps(i,1)+c1(i,1)+c2(i,1)
      pp(i,02)=pxbx(i)*ps(i,2)+c1(i,2)
      pp(i,03)=pxbx(i)*ps(i,3)+c1(i,3)
      pp(i,04)=pyby(i)*ps(i,1)
      pp(i,05)=pyby(i)*ps(i,2)        +c2(i,1)
      pp(i,06)=pyby(i)*ps(i,3)
      pp(i,07)=pzbz(i)*ps(i,1)
      pp(i,08)=pzbz(i)*ps(i,2)
      pp(i,09)=pzbz(i)*ps(i,3)        +c2(i,1)
      pp(i,10)=pxbx(i)*ps(i,4)        +c2(i,2)
      pp(i,11)=pxbx(i)*ps(i,5)
      pp(i,12)=pxbx(i)*ps(i,6)
      pp(i,13)=pyby(i)*ps(i,4)+c1(i,1)
      pp(i,14)=pyby(i)*ps(i,5)+c1(i,2)+c2(i,2)
      pp(i,15)=pyby(i)*ps(i,6)+c1(i,3)
      pp(i,16)=pzbz(i)*ps(i,4)
      pp(i,17)=pzbz(i)*ps(i,5)
      pp(i,18)=pzbz(i)*ps(i,6)        +c2(i,2)
      pp(i,19)=pxbx(i)*ps(i,7)        +c2(i,3)
      pp(i,20)=pxbx(i)*ps(i,8)
      pp(i,21)=pxbx(i)*ps(i,9)
      pp(i,22)=pyby(i)*ps(i,7)
      pp(i,23)=pyby(i)*ps(i,8)        +c2(i,3)
      pp(i,24)=pyby(i)*ps(i,9)
      pp(i,25)=pzbz(i)*ps(i,7)+c1(i,1)
      pp(i,26)=pzbz(i)*ps(i,8)+c1(i,2)
 1012 pp(i,27)=pzbz(i)*ps(i,9)+c1(i,3)+c2(i,3)

      do 1013 j=1,6
      do 1013 i=1,n
 1013 c1(i,j)=dso(i,j)/(two*zeta(i))

      do 1014 j=1,9
      do 1014 i=1,n
 1014 c2(i,j)=ps(i,j)/(two*zeta(i))

      do 1015 i=1,n
      dp(i,01)=pxbx(i)*ds(i,01)+c1(i,1)+c2(i,1)+c2(i,1)
      dp(i,02)=pxbx(i)*ds(i,02)        +c2(i,2)+c2(i,2)
      dp(i,03)=pxbx(i)*ds(i,03)        +c2(i,3)+c2(i,3)
      dp(i,04)=pyby(i)*ds(i,01)
      dp(i,05)=pyby(i)*ds(i,02)+c1(i,1)
      dp(i,06)=pyby(i)*ds(i,03)
      dp(i,07)=pzbz(i)*ds(i,01)
      dp(i,08)=pzbz(i)*ds(i,02)
      dp(i,09)=pzbz(i)*ds(i,03)+c1(i,1)
      dp(i,10)=pxbx(i)*ds(i,04)+c1(i,2)+c2(i,4)
      dp(i,11)=pxbx(i)*ds(i,05)        +c2(i,5)
      dp(i,12)=pxbx(i)*ds(i,06)        +c2(i,6)
      dp(i,13)=pyby(i)*ds(i,04)        +c2(i,1)
      dp(i,14)=pyby(i)*ds(i,05)+c1(i,2)+c2(i,2)
      dp(i,15)=pyby(i)*ds(i,06)        +c2(i,3)
      dp(i,16)=pzbz(i)*ds(i,04)
      dp(i,17)=pzbz(i)*ds(i,05)
      dp(i,18)=pzbz(i)*ds(i,06)+c1(i,2)
      dp(i,19)=pxbx(i)*ds(i,07)+c1(i,3)+c2(i,7)
      dp(i,20)=pxbx(i)*ds(i,08)        +c2(i,8)
      dp(i,21)=pxbx(i)*ds(i,09)        +c2(i,9)
      dp(i,22)=pyby(i)*ds(i,07)
      dp(i,23)=pyby(i)*ds(i,08)+c1(i,3)
      dp(i,24)=pyby(i)*ds(i,09)
      dp(i,25)=pzbz(i)*ds(i,07)        +c2(i,1)
      dp(i,26)=pzbz(i)*ds(i,08)        +c2(i,2)
      dp(i,27)=pzbz(i)*ds(i,09)+c1(i,3)+c2(i,3)
      dp(i,28)=pxbx(i)*ds(i,10)+c1(i,4)
      dp(i,29)=pxbx(i)*ds(i,11)
      dp(i,30)=pxbx(i)*ds(i,12)
      dp(i,31)=pyby(i)*ds(i,10)        +c2(i,4)+c2(i,4)
      dp(i,32)=pyby(i)*ds(i,11)+c1(i,4)+c2(i,5)+c2(i,5)
      dp(i,33)=pyby(i)*ds(i,12)        +c2(i,6)+c2(i,6)
      dp(i,34)=pzbz(i)*ds(i,10)
      dp(i,35)=pzbz(i)*ds(i,11)
      dp(i,36)=pzbz(i)*ds(i,12)+c1(i,4)
      dp(i,37)=pxbx(i)*ds(i,13)+c1(i,5)
      dp(i,38)=pxbx(i)*ds(i,14)
      dp(i,39)=pxbx(i)*ds(i,15)
      dp(i,40)=pyby(i)*ds(i,13)        +c2(i,7)
      dp(i,41)=pyby(i)*ds(i,14)+c1(i,5)+c2(i,8)
      dp(i,42)=pyby(i)*ds(i,15)        +c2(i,9)
      dp(i,43)=pzbz(i)*ds(i,13)        +c2(i,4)
      dp(i,44)=pzbz(i)*ds(i,14)        +c2(i,5)
      dp(i,45)=pzbz(i)*ds(i,15)+c1(i,5)+c2(i,6)
      dp(i,46)=pxbx(i)*ds(i,16)+c1(i,6)
      dp(i,47)=pxbx(i)*ds(i,17)
      dp(i,48)=pxbx(i)*ds(i,18)
      dp(i,49)=pyby(i)*ds(i,16)
      dp(i,50)=pyby(i)*ds(i,17)+c1(i,6)
      dp(i,51)=pyby(i)*ds(i,18)
      dp(i,52)=pzbz(i)*ds(i,16)        +c2(i,7)+c2(i,7)
      dp(i,53)=pzbz(i)*ds(i,17)        +c2(i,8)+c2(i,8)
 1015 dp(i,54)=pzbz(i)*ds(i,18)+c1(i,6)+c2(i,9)+c2(i,9)

      do 1016 j=1,18
      do 1016 i=1,n
 1016 c1(i,j)=dpo(i,j)/(two*zeta(i))

      do 1017 j=1,18
      do 1017 i=1,n
 1017 c2(i,j)=ds(i,j)/(two*zeta(i))

      do 1018 j=1,27
      do 1018 i=1,n
 1018 c3(i,j)=pp(i,j)/(two*zeta(i))

      do 1019 i=1,n
      dd(i,001)=pxbx(i)*dp(i,01)+c1(i,01)+c2(i,01)+c3(i,01)+c3(i,01)
      dd(i,002)=pxbx(i)*dp(i,02)         +c2(i,02)+c3(i,02)+c3(i,02)
      dd(i,003)=pxbx(i)*dp(i,03)         +c2(i,03)+c3(i,03)+c3(i,03)
      dd(i,004)=pyby(i)*dp(i,01)
      dd(i,005)=pyby(i)*dp(i,02)+c1(i,01)
      dd(i,006)=pyby(i)*dp(i,03)
      dd(i,007)=pzbz(i)*dp(i,01)
      dd(i,008)=pzbz(i)*dp(i,02)
      dd(i,009)=pzbz(i)*dp(i,03)+c1(i,01)
      dd(i,010)=pyby(i)*dp(i,04)         +c2(i,01)
      dd(i,011)=pyby(i)*dp(i,05)+c1(i,02)+c2(i,02)
      dd(i,012)=pyby(i)*dp(i,06)         +c2(i,03)
      dd(i,013)=pzbz(i)*dp(i,04)
      dd(i,014)=pzbz(i)*dp(i,05)
      dd(i,015)=pzbz(i)*dp(i,06)+c1(i,02)
      dd(i,016)=pzbz(i)*dp(i,07)         +c2(i,01)
      dd(i,017)=pzbz(i)*dp(i,08)         +c2(i,02)
      dd(i,018)=pzbz(i)*dp(i,09)+c1(i,03)+c2(i,03)
      dd(i,019)=pxbx(i)*dp(i,10)+c1(i,04)+c2(i,04)+c3(i,10)
      dd(i,020)=pxbx(i)*dp(i,11)         +c2(i,05)+c3(i,11)
      dd(i,021)=pxbx(i)*dp(i,12)         +c2(i,06)+c3(i,12)
      dd(i,022)=pyby(i)*dp(i,10)                  +c3(i,01)
      dd(i,023)=pyby(i)*dp(i,11)+c1(i,04)         +c3(i,02)
      dd(i,024)=pyby(i)*dp(i,12)                  +c3(i,03)
      dd(i,025)=pzbz(i)*dp(i,10)
      dd(i,026)=pzbz(i)*dp(i,11)
      dd(i,027)=pzbz(i)*dp(i,12)+c1(i,04)
      dd(i,028)=pyby(i)*dp(i,13)         +c2(i,04)+c3(i,04)
      dd(i,029)=pyby(i)*dp(i,14)+c1(i,05)+c2(i,05)+c3(i,05)
      dd(i,030)=pyby(i)*dp(i,15)         +c2(i,06)+c3(i,06)
      dd(i,031)=pzbz(i)*dp(i,13)
      dd(i,032)=pzbz(i)*dp(i,14)
      dd(i,033)=pzbz(i)*dp(i,15)+c1(i,05)
      dd(i,034)=pzbz(i)*dp(i,16)         +c2(i,04)
      dd(i,035)=pzbz(i)*dp(i,17)         +c2(i,05)
      dd(i,036)=pzbz(i)*dp(i,18)+c1(i,06)+c2(i,06)
      dd(i,037)=pxbx(i)*dp(i,19)+c1(i,07)+c2(i,07)+c3(i,19)
      dd(i,038)=pxbx(i)*dp(i,20)         +c2(i,08)+c3(i,20)
      dd(i,039)=pxbx(i)*dp(i,21)         +c2(i,09)+c3(i,21)
      dd(i,040)=pyby(i)*dp(i,19)
      dd(i,041)=pyby(i)*dp(i,20)+c1(i,07)
      dd(i,042)=pyby(i)*dp(i,21)
      dd(i,043)=pzbz(i)*dp(i,19)                  +c3(i,01)
      dd(i,044)=pzbz(i)*dp(i,20)                  +c3(i,02)
      dd(i,045)=pzbz(i)*dp(i,21)+c1(i,07)         +c3(i,03)
      dd(i,046)=pyby(i)*dp(i,22)         +c2(i,07)
      dd(i,047)=pyby(i)*dp(i,23)+c1(i,08)+c2(i,08)
      dd(i,048)=pyby(i)*dp(i,24)         +c2(i,09)
      dd(i,049)=pzbz(i)*dp(i,22)                  +c3(i,04)
      dd(i,050)=pzbz(i)*dp(i,23)                  +c3(i,05)
      dd(i,051)=pzbz(i)*dp(i,24)+c1(i,08)         +c3(i,06)
      dd(i,052)=pzbz(i)*dp(i,25)         +c2(i,07)+c3(i,07)
      dd(i,053)=pzbz(i)*dp(i,26)         +c2(i,08)+c3(i,08)
      dd(i,054)=pzbz(i)*dp(i,27)+c1(i,09)+c2(i,09)+c3(i,09)
      dd(i,055)=pxbx(i)*dp(i,28)+c1(i,10)+c2(i,10)
      dd(i,056)=pxbx(i)*dp(i,29)         +c2(i,11)
      dd(i,057)=pxbx(i)*dp(i,30)         +c2(i,12)
      dd(i,058)=pyby(i)*dp(i,28)                  +c3(i,10)+c3(i,10)
      dd(i,059)=pyby(i)*dp(i,29)+c1(i,10)         +c3(i,11)+c3(i,11)
      dd(i,060)=pyby(i)*dp(i,30)                  +c3(i,12)+c3(i,12)
      dd(i,061)=pzbz(i)*dp(i,28)
      dd(i,062)=pzbz(i)*dp(i,29)
      dd(i,063)=pzbz(i)*dp(i,30)+c1(i,10)
      dd(i,064)=pyby(i)*dp(i,31)         +c2(i,10)+c3(i,13)+c3(i,13)
      dd(i,065)=pyby(i)*dp(i,32)+c1(i,11)+c2(i,11)+c3(i,14)+c3(i,14)
      dd(i,066)=pyby(i)*dp(i,33)         +c2(i,12)+c3(i,15)+c3(i,15)
      dd(i,067)=pzbz(i)*dp(i,31)
      dd(i,068)=pzbz(i)*dp(i,32)
      dd(i,069)=pzbz(i)*dp(i,33)+c1(i,11)
      dd(i,070)=pzbz(i)*dp(i,34)         +c2(i,10)
      dd(i,071)=pzbz(i)*dp(i,35)         +c2(i,11)
      dd(i,072)=pzbz(i)*dp(i,36)+c1(i,12)+c2(i,12)
      dd(i,073)=pxbx(i)*dp(i,37)+c1(i,13)+c2(i,13)
      dd(i,074)=pxbx(i)*dp(i,38)         +c2(i,14)
      dd(i,075)=pxbx(i)*dp(i,39)         +c2(i,15)
      dd(i,076)=pyby(i)*dp(i,37)                  +c3(i,19)
      dd(i,077)=pyby(i)*dp(i,38)+c1(i,13)         +c3(i,20)
      dd(i,078)=pyby(i)*dp(i,39)                  +c3(i,21)
      dd(i,079)=pzbz(i)*dp(i,37)                  +c3(i,10)
      dd(i,080)=pzbz(i)*dp(i,38)                  +c3(i,11)
      dd(i,081)=pzbz(i)*dp(i,39)+c1(i,13)         +c3(i,12)
      dd(i,082)=pyby(i)*dp(i,40)         +c2(i,13)+c3(i,22)
      dd(i,083)=pyby(i)*dp(i,41)+c1(i,14)+c2(i,14)+c3(i,23)
      dd(i,084)=pyby(i)*dp(i,42)         +c2(i,15)+c3(i,24)
      dd(i,085)=pzbz(i)*dp(i,40)                  +c3(i,13)
      dd(i,086)=pzbz(i)*dp(i,41)                  +c3(i,14)
      dd(i,087)=pzbz(i)*dp(i,42)+c1(i,14)         +c3(i,15)
      dd(i,088)=pzbz(i)*dp(i,43)         +c2(i,13)+c3(i,16)
      dd(i,089)=pzbz(i)*dp(i,44)         +c2(i,14)+c3(i,17)
      dd(i,090)=pzbz(i)*dp(i,45)+c1(i,15)+c2(i,15)+c3(i,18)
      dd(i,091)=pxbx(i)*dp(i,46)+c1(i,16)+c2(i,16)
      dd(i,092)=pxbx(i)*dp(i,47)         +c2(i,17)
      dd(i,093)=pxbx(i)*dp(i,48)         +c2(i,18)
      dd(i,094)=pyby(i)*dp(i,46)
      dd(i,095)=pyby(i)*dp(i,47)+c1(i,16)
      dd(i,096)=pyby(i)*dp(i,48)
      dd(i,097)=pzbz(i)*dp(i,46)                  +c3(i,19)+c3(i,19)
      dd(i,098)=pzbz(i)*dp(i,47)                  +c3(i,20)+c3(i,20)
      dd(i,099)=pzbz(i)*dp(i,48)+c1(i,16)         +c3(i,21)+c3(i,21)
      dd(i,100)=pyby(i)*dp(i,49)         +c2(i,16)
      dd(i,101)=pyby(i)*dp(i,50)+c1(i,17)+c2(i,17)
      dd(i,102)=pyby(i)*dp(i,51)         +c2(i,18)
      dd(i,103)=pzbz(i)*dp(i,49)                  +c3(i,22)+c3(i,22)
      dd(i,104)=pzbz(i)*dp(i,50)                  +c3(i,23)+c3(i,23)
      dd(i,105)=pzbz(i)*dp(i,51)+c1(i,17)         +c3(i,24)+c3(i,24)
      dd(i,106)=pzbz(i)*dp(i,52)         +c2(i,16)+c3(i,25)+c3(i,25)
      dd(i,107)=pzbz(i)*dp(i,53)         +c2(i,17)+c3(i,26)+c3(i,26)
 1019 dd(i,108)=pzbz(i)*dp(i,54)+c1(i,18)+c2(i,18)+c3(i,27)+c3(i,27)

      f1=(one/sqrt3)**1
      f2=(one/sqrt3)**2

      do 1020 i=1,n
      ii=icontr(i)
      x_moment(inddyy(ii,01))=x_moment(inddyy(ii,01))+dd(i,001)*f2
      x_moment(inddyy(ii,07))=x_moment(inddyy(ii,07))+dd(i,019)*f1
      x_moment(inddyy(ii,08))=x_moment(inddyy(ii,08))+dd(i,022)
      x_moment(inddyy(ii,13))=x_moment(inddyy(ii,13))+dd(i,037)*f1
      x_moment(inddyy(ii,14))=x_moment(inddyy(ii,14))+dd(i,040)
      x_moment(inddyy(ii,15))=x_moment(inddyy(ii,15))+dd(i,043)
      x_moment(inddyy(ii,19))=x_moment(inddyy(ii,19))+dd(i,055)*f2
      x_moment(inddyy(ii,20))=x_moment(inddyy(ii,20))+dd(i,058)*f1
      x_moment(inddyy(ii,21))=x_moment(inddyy(ii,21))+dd(i,061)*f1
      x_moment(inddyy(ii,22))=x_moment(inddyy(ii,22))+dd(i,064)*f2
      x_moment(inddyy(ii,25))=x_moment(inddyy(ii,25))+dd(i,073)*f1
      x_moment(inddyy(ii,26))=x_moment(inddyy(ii,26))+dd(i,076)
      x_moment(inddyy(ii,27))=x_moment(inddyy(ii,27))+dd(i,079)
      x_moment(inddyy(ii,28))=x_moment(inddyy(ii,28))+dd(i,082)*f1
      x_moment(inddyy(ii,29))=x_moment(inddyy(ii,29))+dd(i,085)
      x_moment(inddyy(ii,31))=x_moment(inddyy(ii,31))+dd(i,091)*f2
      x_moment(inddyy(ii,32))=x_moment(inddyy(ii,32))+dd(i,094)*f1
      x_moment(inddyy(ii,33))=x_moment(inddyy(ii,33))+dd(i,097)*f1
      x_moment(inddyy(ii,34))=x_moment(inddyy(ii,34))+dd(i,100)*f2
      x_moment(inddyy(ii,35))=x_moment(inddyy(ii,35))+dd(i,103)*f1
      x_moment(inddyy(ii,36))=x_moment(inddyy(ii,36))+dd(i,106)*f2
      y_moment(inddyy(ii,01))=y_moment(inddyy(ii,01))+dd(i,002)*f2
      y_moment(inddyy(ii,07))=y_moment(inddyy(ii,07))+dd(i,020)*f1
      y_moment(inddyy(ii,08))=y_moment(inddyy(ii,08))+dd(i,023)
      y_moment(inddyy(ii,13))=y_moment(inddyy(ii,13))+dd(i,038)*f1
      y_moment(inddyy(ii,14))=y_moment(inddyy(ii,14))+dd(i,041)
      y_moment(inddyy(ii,15))=y_moment(inddyy(ii,15))+dd(i,044)
      y_moment(inddyy(ii,19))=y_moment(inddyy(ii,19))+dd(i,056)*f2
      y_moment(inddyy(ii,20))=y_moment(inddyy(ii,20))+dd(i,059)*f1
      y_moment(inddyy(ii,21))=y_moment(inddyy(ii,21))+dd(i,062)*f1
      y_moment(inddyy(ii,22))=y_moment(inddyy(ii,22))+dd(i,065)*f2
      y_moment(inddyy(ii,25))=y_moment(inddyy(ii,25))+dd(i,074)*f1
      y_moment(inddyy(ii,26))=y_moment(inddyy(ii,26))+dd(i,077)
      y_moment(inddyy(ii,27))=y_moment(inddyy(ii,27))+dd(i,080)
      y_moment(inddyy(ii,28))=y_moment(inddyy(ii,28))+dd(i,083)*f1
      y_moment(inddyy(ii,29))=y_moment(inddyy(ii,29))+dd(i,086)
      y_moment(inddyy(ii,31))=y_moment(inddyy(ii,31))+dd(i,092)*f2
      y_moment(inddyy(ii,32))=y_moment(inddyy(ii,32))+dd(i,095)*f1
      y_moment(inddyy(ii,33))=y_moment(inddyy(ii,33))+dd(i,098)*f1
      y_moment(inddyy(ii,34))=y_moment(inddyy(ii,34))+dd(i,101)*f2
      y_moment(inddyy(ii,35))=y_moment(inddyy(ii,35))+dd(i,104)*f1
      y_moment(inddyy(ii,36))=y_moment(inddyy(ii,36))+dd(i,107)*f2
      z_moment(inddyy(ii,01))=z_moment(inddyy(ii,01))+dd(i,003)*f2
      z_moment(inddyy(ii,07))=z_moment(inddyy(ii,07))+dd(i,021)*f1
      z_moment(inddyy(ii,08))=z_moment(inddyy(ii,08))+dd(i,024)
      z_moment(inddyy(ii,13))=z_moment(inddyy(ii,13))+dd(i,039)*f1
      z_moment(inddyy(ii,14))=z_moment(inddyy(ii,14))+dd(i,042)
      z_moment(inddyy(ii,15))=z_moment(inddyy(ii,15))+dd(i,045)
      z_moment(inddyy(ii,19))=z_moment(inddyy(ii,19))+dd(i,057)*f2
      z_moment(inddyy(ii,20))=z_moment(inddyy(ii,20))+dd(i,060)*f1
      z_moment(inddyy(ii,21))=z_moment(inddyy(ii,21))+dd(i,063)*f1
      z_moment(inddyy(ii,22))=z_moment(inddyy(ii,22))+dd(i,066)*f2
      z_moment(inddyy(ii,25))=z_moment(inddyy(ii,25))+dd(i,075)*f1
      z_moment(inddyy(ii,26))=z_moment(inddyy(ii,26))+dd(i,078)
      z_moment(inddyy(ii,27))=z_moment(inddyy(ii,27))+dd(i,081)
      z_moment(inddyy(ii,28))=z_moment(inddyy(ii,28))+dd(i,084)*f1
      z_moment(inddyy(ii,29))=z_moment(inddyy(ii,29))+dd(i,087)
      z_moment(inddyy(ii,31))=z_moment(inddyy(ii,31))+dd(i,093)*f2
      z_moment(inddyy(ii,32))=z_moment(inddyy(ii,32))+dd(i,096)*f1
      z_moment(inddyy(ii,33))=z_moment(inddyy(ii,33))+dd(i,099)*f1
      z_moment(inddyy(ii,34))=z_moment(inddyy(ii,34))+dd(i,102)*f2
      z_moment(inddyy(ii,35))=z_moment(inddyy(ii,35))+dd(i,105)*f1
 1020 z_moment(inddyy(ii,36))=z_moment(inddyy(ii,36))+dd(i,108)*f2

      do 1021 i=1,n
      ii=icontr(i)
      if(iminj(ii).ne.0) then

            x_moment(inddyy(ii,02))=x_moment(inddyy(ii,02))+dd(i,004)*f1
            x_moment(inddyy(ii,03))=x_moment(inddyy(ii,03))+dd(i,007)*f1
            x_moment(inddyy(ii,04))=x_moment(inddyy(ii,04))+dd(i,010)*f2
            x_moment(inddyy(ii,05))=x_moment(inddyy(ii,05))+dd(i,013)*f1
            x_moment(inddyy(ii,06))=x_moment(inddyy(ii,06))+dd(i,016)*f2
            x_moment(inddyy(ii,09))=x_moment(inddyy(ii,09))+dd(i,025)
            x_moment(inddyy(ii,10))=x_moment(inddyy(ii,10))+dd(i,028)*f1
            x_moment(inddyy(ii,11))=x_moment(inddyy(ii,11))+dd(i,031)
            x_moment(inddyy(ii,12))=x_moment(inddyy(ii,12))+dd(i,034)*f1
            x_moment(inddyy(ii,16))=x_moment(inddyy(ii,16))+dd(i,046)*f1
            x_moment(inddyy(ii,17))=x_moment(inddyy(ii,17))+dd(i,049)
            x_moment(inddyy(ii,18))=x_moment(inddyy(ii,18))+dd(i,052)*f1
            x_moment(inddyy(ii,23))=x_moment(inddyy(ii,23))+dd(i,067)*f1
            x_moment(inddyy(ii,24))=x_moment(inddyy(ii,24))+dd(i,070)*f2
            x_moment(inddyy(ii,30))=x_moment(inddyy(ii,30))+dd(i,088)*f1
            y_moment(inddyy(ii,02))=y_moment(inddyy(ii,02))+dd(i,005)*f1
            y_moment(inddyy(ii,03))=y_moment(inddyy(ii,03))+dd(i,008)*f1
            y_moment(inddyy(ii,04))=y_moment(inddyy(ii,04))+dd(i,011)*f2
            y_moment(inddyy(ii,05))=y_moment(inddyy(ii,05))+dd(i,014)*f1
            y_moment(inddyy(ii,06))=y_moment(inddyy(ii,06))+dd(i,017)*f2
            y_moment(inddyy(ii,09))=y_moment(inddyy(ii,09))+dd(i,026)
            y_moment(inddyy(ii,10))=y_moment(inddyy(ii,10))+dd(i,029)*f1
            y_moment(inddyy(ii,11))=y_moment(inddyy(ii,11))+dd(i,032)
            y_moment(inddyy(ii,12))=y_moment(inddyy(ii,12))+dd(i,035)*f1
            y_moment(inddyy(ii,16))=y_moment(inddyy(ii,16))+dd(i,047)*f1
            y_moment(inddyy(ii,17))=y_moment(inddyy(ii,17))+dd(i,050)
            y_moment(inddyy(ii,18))=y_moment(inddyy(ii,18))+dd(i,053)*f1
            y_moment(inddyy(ii,23))=y_moment(inddyy(ii,23))+dd(i,068)*f1
            y_moment(inddyy(ii,24))=y_moment(inddyy(ii,24))+dd(i,071)*f2
            y_moment(inddyy(ii,30))=y_moment(inddyy(ii,30))+dd(i,089)*f1
            z_moment(inddyy(ii,02))=z_moment(inddyy(ii,02))+dd(i,006)*f1
            z_moment(inddyy(ii,03))=z_moment(inddyy(ii,03))+dd(i,009)*f1
            z_moment(inddyy(ii,04))=z_moment(inddyy(ii,04))+dd(i,012)*f2
            z_moment(inddyy(ii,05))=z_moment(inddyy(ii,05))+dd(i,015)*f1
            z_moment(inddyy(ii,06))=z_moment(inddyy(ii,06))+dd(i,018)*f2
            z_moment(inddyy(ii,09))=z_moment(inddyy(ii,09))+dd(i,027)
            z_moment(inddyy(ii,10))=z_moment(inddyy(ii,10))+dd(i,030)*f1
            z_moment(inddyy(ii,11))=z_moment(inddyy(ii,11))+dd(i,033)
            z_moment(inddyy(ii,12))=z_moment(inddyy(ii,12))+dd(i,036)*f1
            z_moment(inddyy(ii,16))=z_moment(inddyy(ii,16))+dd(i,048)*f1
            z_moment(inddyy(ii,17))=z_moment(inddyy(ii,17))+dd(i,051)
            z_moment(inddyy(ii,18))=z_moment(inddyy(ii,18))+dd(i,054)*f1
            z_moment(inddyy(ii,23))=z_moment(inddyy(ii,23))+dd(i,069)*f1
            z_moment(inddyy(ii,24))=z_moment(inddyy(ii,24))+dd(i,072)*f2
            z_moment(inddyy(ii,30))=z_moment(inddyy(ii,30))+dd(i,090)*f1

                         endif
 1021 continue

      return
      end
