      subroutine compg0(iatom,ncntrt,npts,ndm,natoms,nconts,ncontp,
     &                  ncontd,ilfunc,icfunc,ngauss,nptrs,nptrp,nptrd,
     &                  radius,cent,alpha,coeff,x,y,z,qf,extent1,
     &                  extent3,dcc,xx,yy,zz,rr,rralpha,s,dxx,dxy,dxz,
     &                  dyy,dyz,dzz)

c  this subroutine written by alain st-amant of the department of
c  pharmaceutical chemistry, university of california, san francisco.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension ilfunc(*),icfunc(*),ngauss(*),nptrs(*),nptrp(*),nptrd(*)

      dimension cent(3,*),alpha(*),coeff(*)

      dimension x(*),y(*),z(*),qf(ndm,*)

      dimension extent1(*),extent3(*),dcc(natoms,*)
      dimension xx(*),yy(*),zz(*),rr(*),rralpha(*)
      dimension s(*),dxx(*),dxy(*),dxz(*),dyy(*),dyz(*),dzz(*)

      data zero,one,two,three,expcut/0.0d0,1.0d0,2.0d0,3.0d0,50.0d0/

      rsqrt3=one/sqrt(three)

      do 1001 i=1,ncntrt
 1001 extent3(i)=zero

      k=0

      if(nconts.eq.0) return

      do 1002 i=1,nconts

      ilabel=nptrs(i)

      nc=icfunc(ilabel)

      distmin=dcc(nc,iatom)-radius
      if(distmin.gt.extent1(i)) goto 1002

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      do 1003 j=1,npts
 1003 qf(j,k+1)=zero

      do 1004 j=1,npts
      xx(j)=x(j)-cent(1,nc)
      yy(j)=y(j)-cent(2,nc)
 1004 zz(j)=z(j)-cent(3,nc)

      do 1005 j=1,npts
 1005 rr(j)=xx(j)*xx(j)+yy(j)*yy(j)+zz(j)*zz(j)

      do 1006 nprimitive=iptr1,iptr2

      do 1007 j=1,npts
 1007 rralpha(j)=rr(j)*alpha(nprimitive)

      do 1008 j=1,npts
 1008 if(rralpha(j).lt.expcut) qf(j,k+1)=qf(j,k+1)
     &                             +coeff(nprimitive)*exp(-rralpha(j))

 1006 continue

      extent3(k+1)=sumsum(npts,qf(1,k+1))/real64(npts)

 1002 k=k+1

      if(ncontp.eq.0) return

      do 1009 i=1,ncontp

      ilabel=nptrp(i)

      nc=icfunc(ilabel)

      distmin=dcc(nc,iatom)-radius
      if(distmin.gt.extent1(nconts+i)) goto 1009

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      do 1010 j=1,npts
      qf(j,k+1)=zero
      qf(j,k+2)=zero
 1010 qf(j,k+3)=zero

      do 1011 j=1,npts
      xx(j)=x(j)-cent(1,nc)
      yy(j)=y(j)-cent(2,nc)
 1011 zz(j)=z(j)-cent(3,nc)

      do 1012 j=1,npts
 1012 rr(j)=xx(j)*xx(j)+yy(j)*yy(j)+zz(j)*zz(j)

      do 1013 nprimitive=iptr1,iptr2

      do 1014 j=1,npts
 1014 rralpha(j)=rr(j)*alpha(nprimitive)

      do 1015 j=1,npts
      if(rralpha(j).lt.expcut) then

                     s(j)=coeff(nprimitive)*exp(-rralpha(j))

                     qf(j,k+1)=qf(j,k+1)+xx(j)*s(j)
                     qf(j,k+2)=qf(j,k+2)+yy(j)*s(j)
                     qf(j,k+3)=qf(j,k+3)+zz(j)*s(j)

                               endif
 1015 continue

 1013 continue

      extent3(k+1)=sumsum(npts,qf(1,k+1))/real64(npts)
      extent3(k+2)=sumsum(npts,qf(1,k+2))/real64(npts)
      extent3(k+3)=sumsum(npts,qf(1,k+3))/real64(npts)

 1009 k=k+3

      if(ncontd.eq.0) return

      do 1016 i=1,ncontd

      ilabel=nptrd(i)

      nc=icfunc(ilabel)

      distmin=dcc(nc,iatom)-radius
      if(distmin.gt.extent1(nconts+ncontp+i)) goto 1016

      iptr1=ilfunc(ilabel)
      iptr2=iptr1+ngauss(ilabel)-1

      do 1017 j=1,npts
      qf(j,k+1)=zero
      qf(j,k+2)=zero
      qf(j,k+3)=zero
      qf(j,k+4)=zero
      qf(j,k+5)=zero
 1017 qf(j,k+6)=zero

      do 1018 j=1,npts
      xx(j)=x(j)-cent(1,nc)
      yy(j)=y(j)-cent(2,nc)
 1018 zz(j)=z(j)-cent(3,nc)

      do 1019 j=1,npts
      dxx(j)=xx(j)*xx(j)
      dxy(j)=xx(j)*yy(j)
      dxz(j)=xx(j)*zz(j)
      dyy(j)=yy(j)*yy(j)
      dyz(j)=yy(j)*zz(j)
 1019 dzz(j)=zz(j)*zz(j)

      do 1020 j=1,npts
 1020 rr(j)=dxx(j)+dyy(j)+dzz(j)

      do 1021 nprimitive=iptr1,iptr2

      do 1022 j=1,npts
 1022 rralpha(j)=rr(j)*alpha(nprimitive)

      do 1023 j=1,npts
      if(rralpha(j).lt.expcut) then

                     s(j)=coeff(nprimitive)*exp(-rralpha(j))

                     qf(j,k+1)=qf(j,k+1)+dxx(j)*s(j)
                     qf(j,k+2)=qf(j,k+2)+dxy(j)*s(j)
                     qf(j,k+3)=qf(j,k+3)+dxz(j)*s(j)
                     qf(j,k+4)=qf(j,k+4)+dyy(j)*s(j)
                     qf(j,k+5)=qf(j,k+5)+dyz(j)*s(j)
                     qf(j,k+6)=qf(j,k+6)+dzz(j)*s(j)

                             endif
 1023 continue

 1021 continue

      do 1024 j=1,npts
      qf(j,k+1)=qf(j,k+1)*rsqrt3
      qf(j,k+4)=qf(j,k+4)*rsqrt3
 1024 qf(j,k+6)=qf(j,k+6)*rsqrt3

      extent3(k+1)=sumsum(npts,qf(1,k+1))/real64(npts)
      extent3(k+2)=sumsum(npts,qf(1,k+2))/real64(npts)
      extent3(k+3)=sumsum(npts,qf(1,k+3))/real64(npts)
      extent3(k+4)=sumsum(npts,qf(1,k+4))/real64(npts)
      extent3(k+5)=sumsum(npts,qf(1,k+5))/real64(npts)
      extent3(k+6)=sumsum(npts,qf(1,k+6))/real64(npts)

 1016 k=k+6

      return
      end
