      subroutine efipp(m,n,iminj,icontr,inddyy,esp,efix,efiy,efiz,
     &                 ccx,ccy,ccz,g,density,zeta,axbx,ayby,azbz,
     &                 px,py,pz,pxax,pyay,pzaz,base,ss0,ss1,ss2,ps0,
     &                 ps1,pscond,ds0,dscond,ppcond,c,pxcx,pycy,
     &                 pzcz,u,twozeta,ss3,saxs0,says0,sazs0,saxs1,
     &                 says1,sazs1,saxs2,says2,sazs2,paxs0,pays0,pazs0,
     &                 paxs1,pays1,pazs1,daxs0,days0,dazs0,cx,cy,cz,
     &                 paxscond,payscond,pazscond,paxpcond,paypcond,
     &                 pazpcond,daxscond,dayscond,dazscond)

c  this subroutine written by roger gallant and alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension iminj(*),icontr(*),inddyy(m,*)

      dimension g(*),density(*),zeta(*),axbx(*),ayby(*),azbz(*),px(*),
     &          py(*),pz(*),pxax(*),pyay(*),pzaz(*),base(*),ss0(*),
     &          ss1(*),ss2(*),ss3(*),ps0(n,*),ps1(n,*),pscond(m,*),
     &          ds0(n,*),dscond(m,*),ppcond(m,*),c(*),pxcx(*),pycy(*),
     &          pzcz(*),u(*),twozeta(*),saxs0(*),says0(*),sazs0(*),
     &          saxs1(*),says1(*),sazs1(*),saxs2(*),says2(*),sazs2(*),
     &          paxs0(n,*),pays0(n,*),pazs0(n,*),paxs1(n,*),pays1(n,*),
     &          pazs1(n,*),daxs0(n,*),days0(n,*),dazs0(n,*),cx(*),cy(*),
     &          cz(*),paxscond(m,*),payscond(m,*),pazscond(m,*),
     &          paxpcond(m,*),paypcond(m,*),pazpcond(m,*),daxscond(m,*),
     &          dayscond(m,*),dazscond(m,*)

      data zero,half,one,two,pi/0.0d0,0.5d0,
     &                          1.0d0,2.0d0,3.1415926535898d0/

      twopi=two*pi

      do 1001 i=1,n
 1001 twozeta(i)=two*zeta(i)
     
      do 1002 i=1,n 
      pxcx(i)=px(i)-ccx
      pycy(i)=py(i)-ccy
      pzcz(i)=pz(i)-ccz
 1002 u(i)=zeta(i)*(pxcx(i)*pxcx(i)+pycy(i)*pycy(i)+pzcz(i)*pzcz(i))

      do 1003 i=1,n
      call augg(4,u(i),g)
      ss0(i)=twopi/zeta(i)*base(i)*g(1)
      ss1(i)=twopi/zeta(i)*base(i)*g(2)
      ss2(i)=twopi/zeta(i)*base(i)*g(3)
 1003 ss3(i)=twopi/zeta(i)*base(i)*g(4)

      do 1004 i=1,n

      ps0(i,1)=pxax(i)*ss0(i)-pxcx(i)*ss1(i)
      ps0(i,2)=pyay(i)*ss0(i)-pycy(i)*ss1(i)
      ps0(i,3)=pzaz(i)*ss0(i)-pzcz(i)*ss1(i)

      ps1(i,1)=pxax(i)*ss1(i)-pxcx(i)*ss2(i)
      ps1(i,2)=pyay(i)*ss1(i)-pycy(i)*ss2(i)
      ps1(i,3)=pzaz(i)*ss1(i)-pzcz(i)*ss2(i)

 1004 continue

      do 1005 i=1,n
 1005 c(i)=(ss0(i)-ss1(i))/twozeta(i)

      do 1006 i=1,n
      ds0(i,1)=pxax(i)*ps0(i,1)-pxcx(i)*ps1(i,1)+c(i)
      ds0(i,2)=pyay(i)*ps0(i,1)-pycy(i)*ps1(i,1)
      ds0(i,3)=pzaz(i)*ps0(i,1)-pzcz(i)*ps1(i,1)
      ds0(i,4)=pyay(i)*ps0(i,2)-pycy(i)*ps1(i,2)+c(i)
      ds0(i,5)=pzaz(i)*ps0(i,2)-pzcz(i)*ps1(i,2)
 1006 ds0(i,6)=pzaz(i)*ps0(i,3)-pzcz(i)*ps1(i,3)+c(i)

      do 1007 i=1,n

      saxs0(i)=twozeta(i)*pxcx(i)*ss1(i)
      says0(i)=twozeta(i)*pycy(i)*ss1(i)
      sazs0(i)=twozeta(i)*pzcz(i)*ss1(i)

      saxs1(i)=twozeta(i)*pxcx(i)*ss2(i)
      says1(i)=twozeta(i)*pycy(i)*ss2(i)
      sazs1(i)=twozeta(i)*pzcz(i)*ss2(i)

      saxs2(i)=twozeta(i)*pxcx(i)*ss3(i)
      says2(i)=twozeta(i)*pycy(i)*ss3(i)
      sazs2(i)=twozeta(i)*pzcz(i)*ss3(i)

 1007 continue

      do 1008 i=1,n

      paxs0(i,1)=pxax(i)*saxs0(i)-pxcx(i)*saxs1(i)+ss1(i)
      paxs0(i,2)=pyay(i)*saxs0(i)-pycy(i)*saxs1(i)
      paxs0(i,3)=pzaz(i)*saxs0(i)-pzcz(i)*saxs1(i)
      pays0(i,1)=pxax(i)*says0(i)-pxcx(i)*says1(i)
      pays0(i,2)=pyay(i)*says0(i)-pycy(i)*says1(i)+ss1(i)
      pays0(i,3)=pzaz(i)*says0(i)-pzcz(i)*says1(i)
      pazs0(i,1)=pxax(i)*sazs0(i)-pxcx(i)*sazs1(i)
      pazs0(i,2)=pyay(i)*sazs0(i)-pycy(i)*sazs1(i)
      pazs0(i,3)=pzaz(i)*sazs0(i)-pzcz(i)*sazs1(i)+ss1(i)

      paxs1(i,1)=pxax(i)*saxs1(i)-pxcx(i)*saxs2(i)+ss2(i)
      paxs1(i,2)=pyay(i)*saxs1(i)-pycy(i)*saxs2(i)
      paxs1(i,3)=pzaz(i)*saxs1(i)-pzcz(i)*saxs2(i)
      pays1(i,1)=pxax(i)*says1(i)-pxcx(i)*says2(i)
      pays1(i,2)=pyay(i)*says1(i)-pycy(i)*says2(i)+ss2(i)
      pays1(i,3)=pzaz(i)*says1(i)-pzcz(i)*says2(i)
      pazs1(i,1)=pxax(i)*sazs1(i)-pxcx(i)*sazs2(i)
      pazs1(i,2)=pyay(i)*sazs1(i)-pycy(i)*sazs2(i)
      pazs1(i,3)=pzaz(i)*sazs1(i)-pzcz(i)*sazs2(i)+ss2(i)

 1008 continue

      do 1009 i=1,n
      cx(i)=(saxs0(i)-saxs1(i))/twozeta(i)
      cy(i)=(says0(i)-says1(i))/twozeta(i)
 1009 cz(i)=(sazs0(i)-sazs1(i))/twozeta(i)

      do 1010 i=1,n
      daxs0(i,1)=pxax(i)*paxs0(i,1)-pxcx(i)*paxs1(i,1)+cx(i)+ps1(i,1)
      daxs0(i,2)=pyay(i)*paxs0(i,1)-pycy(i)*paxs1(i,1)
      daxs0(i,3)=pzaz(i)*paxs0(i,1)-pzcz(i)*paxs1(i,1)
      daxs0(i,4)=pyay(i)*paxs0(i,2)-pycy(i)*paxs1(i,2)+cx(i)
      daxs0(i,5)=pzaz(i)*paxs0(i,2)-pzcz(i)*paxs1(i,2)
      daxs0(i,6)=pzaz(i)*paxs0(i,3)-pzcz(i)*paxs1(i,3)+cx(i)
      days0(i,1)=pxax(i)*pays0(i,1)-pxcx(i)*pays1(i,1)+cy(i)
      days0(i,2)=pyay(i)*pays0(i,1)-pycy(i)*pays1(i,1)      +ps1(i,1)
      days0(i,3)=pzaz(i)*pays0(i,1)-pzcz(i)*pays1(i,1)
      days0(i,4)=pyay(i)*pays0(i,2)-pycy(i)*pays1(i,2)+cy(i)+ps1(i,2)
      days0(i,5)=pzaz(i)*pays0(i,2)-pzcz(i)*pays1(i,2)
      days0(i,6)=pzaz(i)*pays0(i,3)-pzcz(i)*pays1(i,3)+cy(i)
      dazs0(i,1)=pxax(i)*pazs0(i,1)-pxcx(i)*pazs1(i,1)+cz(i)
      dazs0(i,2)=pyay(i)*pazs0(i,1)-pycy(i)*pazs1(i,1)
      dazs0(i,3)=pzaz(i)*pazs0(i,1)-pzcz(i)*pazs1(i,1)      +ps1(i,1)
      dazs0(i,4)=pyay(i)*pazs0(i,2)-pycy(i)*pazs1(i,2)+cz(i)
      dazs0(i,5)=pzaz(i)*pazs0(i,2)-pzcz(i)*pazs1(i,2)      +ps1(i,2)
 1010 dazs0(i,6)=pzaz(i)*pazs0(i,3)-pzcz(i)*pazs1(i,3)+cz(i)+ps1(i,3)

      do 1011 j=1,3
      do 1011 i=1,m
 1011 pscond(i,j)=zero

      do 1012 j=1,3
      do 1012 i=1,n
 1012 pscond(icontr(i),j)=pscond(icontr(i),j)+ps0(i,j)

      do 1013 j=1,6
      do 1013 i=1,m
 1013 dscond(i,j)=zero

      do 1014 j=1,6
      do 1014 i=1,n
 1014 dscond(icontr(i),j)=dscond(icontr(i),j)+ds0(i,j)

      do 1015 i=1,m
      ppcond(i,1)=axbx(i)*pscond(i,1)+dscond(i,1)
      ppcond(i,2)=ayby(i)*pscond(i,1)+dscond(i,2)
      ppcond(i,3)=azbz(i)*pscond(i,1)+dscond(i,3)
      ppcond(i,4)=axbx(i)*pscond(i,2)+dscond(i,2)
      ppcond(i,5)=ayby(i)*pscond(i,2)+dscond(i,4)
      ppcond(i,6)=azbz(i)*pscond(i,2)+dscond(i,5)
      ppcond(i,7)=axbx(i)*pscond(i,3)+dscond(i,3)
      ppcond(i,8)=ayby(i)*pscond(i,3)+dscond(i,5)
 1015 ppcond(i,9)=azbz(i)*pscond(i,3)+dscond(i,6)

      do 1016 j=1,3
      do 1016 i=1,m
      paxscond(i,j)=zero
      payscond(i,j)=zero
 1016 pazscond(i,j)=zero

      do 1017 j=1,3
      do 1017 i=1,n
      paxscond(icontr(i),j)=paxscond(icontr(i),j)+paxs0(i,j)
      payscond(icontr(i),j)=payscond(icontr(i),j)+pays0(i,j)
 1017 pazscond(icontr(i),j)=pazscond(icontr(i),j)+pazs0(i,j)

      do 1018 j=1,6
      do 1018 i=1,m
      daxscond(i,j)=zero
      dayscond(i,j)=zero
 1018 dazscond(i,j)=zero

      do 1019 j=1,6
      do 1019 i=1,n
      daxscond(icontr(i),j)=daxscond(icontr(i),j)+daxs0(i,j)
      dayscond(icontr(i),j)=dayscond(icontr(i),j)+days0(i,j)
 1019 dazscond(icontr(i),j)=dazscond(icontr(i),j)+dazs0(i,j)

      do 1020 i=1,m
      paxpcond(i,1)=axbx(i)*paxscond(i,1)+daxscond(i,1)
      paxpcond(i,2)=ayby(i)*paxscond(i,1)+daxscond(i,2)
      paxpcond(i,3)=azbz(i)*paxscond(i,1)+daxscond(i,3)
      paxpcond(i,4)=axbx(i)*paxscond(i,2)+daxscond(i,2)
      paxpcond(i,5)=ayby(i)*paxscond(i,2)+daxscond(i,4)
      paxpcond(i,6)=azbz(i)*paxscond(i,2)+daxscond(i,5)
      paxpcond(i,7)=axbx(i)*paxscond(i,3)+daxscond(i,3)
      paxpcond(i,8)=ayby(i)*paxscond(i,3)+daxscond(i,5)
      paxpcond(i,9)=azbz(i)*paxscond(i,3)+daxscond(i,6)
      paypcond(i,1)=axbx(i)*payscond(i,1)+dayscond(i,1)
      paypcond(i,2)=ayby(i)*payscond(i,1)+dayscond(i,2)
      paypcond(i,3)=azbz(i)*payscond(i,1)+dayscond(i,3)
      paypcond(i,4)=axbx(i)*payscond(i,2)+dayscond(i,2)
      paypcond(i,5)=ayby(i)*payscond(i,2)+dayscond(i,4)
      paypcond(i,6)=azbz(i)*payscond(i,2)+dayscond(i,5)
      paypcond(i,7)=axbx(i)*payscond(i,3)+dayscond(i,3)
      paypcond(i,8)=ayby(i)*payscond(i,3)+dayscond(i,5)
      paypcond(i,9)=azbz(i)*payscond(i,3)+dayscond(i,6)
      pazpcond(i,1)=axbx(i)*pazscond(i,1)+dazscond(i,1)
      pazpcond(i,2)=ayby(i)*pazscond(i,1)+dazscond(i,2)
      pazpcond(i,3)=azbz(i)*pazscond(i,1)+dazscond(i,3)
      pazpcond(i,4)=axbx(i)*pazscond(i,2)+dazscond(i,2)
      pazpcond(i,5)=ayby(i)*pazscond(i,2)+dazscond(i,4)
      pazpcond(i,6)=azbz(i)*pazscond(i,2)+dazscond(i,5)
      pazpcond(i,7)=axbx(i)*pazscond(i,3)+dazscond(i,3)
      pazpcond(i,8)=ayby(i)*pazscond(i,3)+dazscond(i,5)
 1020 pazpcond(i,9)=azbz(i)*pazscond(i,3)+dazscond(i,6)

      do 1021 i=1,m
 1021 esp=esp-density(inddyy(i,1))*ppcond(i,1)
     &       -density(inddyy(i,4))*ppcond(i,4)
     &       -density(inddyy(i,5))*ppcond(i,5)
     &       -density(inddyy(i,7))*ppcond(i,7)
     &       -density(inddyy(i,8))*ppcond(i,8)
     &       -density(inddyy(i,9))*ppcond(i,9)

      do 1022 i=1,m
 1022 if(iminj(i).ne.0) esp=esp-density(inddyy(i,2))*ppcond(i,2)
     &                         -density(inddyy(i,3))*ppcond(i,3)
     &                         -density(inddyy(i,6))*ppcond(i,6)

      do 1023 i=1,m

      efix=efix-density(inddyy(i,1))*paxpcond(i,1)
     &         -density(inddyy(i,4))*paxpcond(i,4)
     &         -density(inddyy(i,5))*paxpcond(i,5)
     &         -density(inddyy(i,7))*paxpcond(i,7)
     &         -density(inddyy(i,8))*paxpcond(i,8)
     &         -density(inddyy(i,9))*paxpcond(i,9)
      efiy=efiy-density(inddyy(i,1))*paypcond(i,1)
     &         -density(inddyy(i,4))*paypcond(i,4)
     &         -density(inddyy(i,5))*paypcond(i,5)
     &         -density(inddyy(i,7))*paypcond(i,7)
     &         -density(inddyy(i,8))*paypcond(i,8)
     &         -density(inddyy(i,9))*paypcond(i,9)
      efiz=efiz-density(inddyy(i,1))*pazpcond(i,1)
     &         -density(inddyy(i,4))*pazpcond(i,4)
     &         -density(inddyy(i,5))*pazpcond(i,5)
     &         -density(inddyy(i,7))*pazpcond(i,7)
     &         -density(inddyy(i,8))*pazpcond(i,8)
     &         -density(inddyy(i,9))*pazpcond(i,9)

 1023 continue

      do 1024 i=1,m
      if(iminj(i).ne.0) then

              efix=efix-density(inddyy(i,2))*paxpcond(i,2)
     &                 -density(inddyy(i,3))*paxpcond(i,3)
     &                 -density(inddyy(i,6))*paxpcond(i,6)
              efiy=efiy-density(inddyy(i,2))*paypcond(i,2)
     &                 -density(inddyy(i,3))*paypcond(i,3)
     &                 -density(inddyy(i,6))*paypcond(i,6)
              efiz=efiz-density(inddyy(i,2))*pazpcond(i,2)
     &                 -density(inddyy(i,3))*pazpcond(i,3)
     &                 -density(inddyy(i,6))*pazpcond(i,6)

                        endif
 1024 continue

      return 
      end 
