      subroutine xvecds(m,n,nxcs,nxcspd,ilfunc,icfunc,icontr,iicontr,
     &                  inddyy,iloc,coord,dmat,vvector,alphaaux,
     &                  coeffs,coeffp,coeffd,zeta,ax,ay,az,px,py,pz,
     &                  base,zetarec,zetafac,efac,gxax,gyay,gzaz,sss,
     &                  pss,dss,dsscond,fss,fsscond,gss,gsscond,dsp,fsp,
     &                  dsd,c,c1,c2,zzeta,aax,aay,aaz,ppx,ppy,ppz,axcx,
     &                  aycy,azcz,gather)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension xcfitp(3),xcfitd(6)

      dimension ilfunc(*),icfunc(*),icontr(*),iicontr(*),inddyy(m,*),
     &          iloc(*)

      dimension coord(3,*),dmat(*),vvector(*),alphaaux(*),coeffs(*),
     &          coeffp(*),coeffd(*),zeta(*),ax(*),ay(*),az(*),px(*),
     &          py(*),pz(*),base(*),zetarec(*),zetafac(*),efac(*),
     &          gxax(*),gyay(*),gzaz(*),sss(*),pss(n,*),dss(n,*),
     &          dsscond(n,*),fss(n,*),fsscond(n,*),gss(n,*),
     &          gsscond(n,*),dsp(n,*),fsp(n,*),dsd(n,*),c(*),c1(n,*),
     &          c2(n,*),zzeta(*),aax(*),aay(*),aaz(*),ppx(*),ppy(*),
     &          ppz(*),axcx(*),aycy(*),azcz(*),gather(n,*)

      data zero,one,two,three,four,five/0.0d0,1.0d0,2.0d0,
     &                                  3.0d0,4.0d0,5.0d0/
      data expcut,calcut,pi/45.0d0,1.0d-16,3.1415926535898d0/

      thrhlf=three/two

      sqrt3=sqrt(three)

      do 1000 i=1,n
 1000 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1001 naux=1,nxcs

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=coeffs(ilaux)

      do 1002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      sss(i)=zero
 1004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 1005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 1005 continue

      do 1006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 1006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 1007 i=1,nn
 1007 zetarec(i)=zetarec(i)/two

      do 1008 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 1008 pss(i,3)=gzaz(i)*sss(i)

      do 1009 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 1009 continue

      do 1010 i=1,nn
 1010 gather(i,1)=zero

      do 1011 j=1,6
      do 1011 i=1,nn
 1011 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*dss(i,j)

      do 1012 i=1,nn
 1012 gather(i,1)=gather(i,1)*xcfits

      do 1013 i=1,nn
 1013 vvector(naux)=vvector(naux)+gather(i,1)

 1001 continue

      do 2001 naux=1,nxcspd

      ilaux=ilfunc(nxcs+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=coeffs(ilaux)

      xcfitp(1)=coeffp(ilaux)
      xcfitp(2)=coeffp(ilaux)
      xcfitp(3)=coeffp(ilaux)

      xcfitd(1)=coeffd(ilaux)/sqrt3
      xcfitd(2)=coeffd(ilaux)
      xcfitd(3)=coeffd(ilaux)
      xcfitd(4)=coeffd(ilaux)/sqrt3
      xcfitd(5)=coeffd(ilaux)
      xcfitd(6)=coeffd(ilaux)/sqrt3

      do 2002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n

      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz

 2003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 2004 i=1,n
      sss(i)=zero
 2004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 2005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      axcx(nn)=ax(i)-ccx
                                      aycy(nn)=ay(i)-ccy
                                      azcz(nn)=az(i)-ccz

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 2005 continue

      do 2006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 2006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 2007 i=1,nn
 2007 zetarec(i)=zetarec(i)/two

      do 2008 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 2008 pss(i,3)=gzaz(i)*sss(i)

      do 2009 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 2009 continue

      do 2010 j=1,3
      do 2010 i=1,nn
 2010 c1(i,j)=zetarec(i)*pss(i,j)

      do 2011 i=1,nn
      fss(i,01)=gxax(i)*dss(i,1)+c1(i,1)+c1(i,1)
      fss(i,02)=gyay(i)*dss(i,1)
      fss(i,03)=gzaz(i)*dss(i,1)
      fss(i,04)=gyay(i)*dss(i,2)+c1(i,1)
      fss(i,05)=gzaz(i)*dss(i,2)
      fss(i,06)=gzaz(i)*dss(i,3)+c1(i,1)
      fss(i,07)=gyay(i)*dss(i,4)+c1(i,2)+c1(i,2)
      fss(i,08)=gzaz(i)*dss(i,4)
      fss(i,09)=gzaz(i)*dss(i,5)+c1(i,2)
 2011 fss(i,10)=gzaz(i)*dss(i,6)+c1(i,3)+c1(i,3)

      do 2012 j=1,6
      do 2012 i=1,nn
 2012 c2(i,j)=zetarec(i)*dss(i,j)

      do 2013 i=1,nn
      gss(i,01)=gxax(i)*fss(i,01)+c2(i,1)*three
      gss(i,02)=gyay(i)*fss(i,01)
      gss(i,03)=gzaz(i)*fss(i,01)
      gss(i,04)=gyay(i)*fss(i,02)+c2(i,1)
      gss(i,05)=gzaz(i)*fss(i,02)
      gss(i,06)=gzaz(i)*fss(i,03)+c2(i,1)
      gss(i,07)=gyay(i)*fss(i,04)+c2(i,2)*two
      gss(i,08)=gzaz(i)*fss(i,04)
      gss(i,09)=gzaz(i)*fss(i,05)+c2(i,2)
      gss(i,10)=gzaz(i)*fss(i,06)+c2(i,3)*two
      gss(i,11)=gyay(i)*fss(i,07)+c2(i,4)*three
      gss(i,12)=gzaz(i)*fss(i,07)
      gss(i,13)=gzaz(i)*fss(i,08)+c2(i,4)
      gss(i,14)=gzaz(i)*fss(i,09)+c2(i,5)*two
 2013 gss(i,15)=gzaz(i)*fss(i,10)+c2(i,6)*three

      do 2014 i=1,nn
      dsp(i,01)=axcx(i)*dss(i,1)+fss(i,01)
      dsp(i,02)=aycy(i)*dss(i,1)+fss(i,02)
      dsp(i,03)=azcz(i)*dss(i,1)+fss(i,03)
      dsp(i,04)=axcx(i)*dss(i,2)+fss(i,02)
      dsp(i,05)=aycy(i)*dss(i,2)+fss(i,04)
      dsp(i,06)=azcz(i)*dss(i,2)+fss(i,05)
      dsp(i,07)=axcx(i)*dss(i,3)+fss(i,03)
      dsp(i,08)=aycy(i)*dss(i,3)+fss(i,05)
      dsp(i,09)=azcz(i)*dss(i,3)+fss(i,06)
      dsp(i,10)=axcx(i)*dss(i,4)+fss(i,04)
      dsp(i,11)=aycy(i)*dss(i,4)+fss(i,07)
      dsp(i,12)=azcz(i)*dss(i,4)+fss(i,08)
      dsp(i,13)=axcx(i)*dss(i,5)+fss(i,05)
      dsp(i,14)=aycy(i)*dss(i,5)+fss(i,08)
      dsp(i,15)=azcz(i)*dss(i,5)+fss(i,09)
      dsp(i,16)=axcx(i)*dss(i,6)+fss(i,06)
      dsp(i,17)=aycy(i)*dss(i,6)+fss(i,09)
 2014 dsp(i,18)=azcz(i)*dss(i,6)+fss(i,10)

      do 2015 i=1,nn
      fsp(i,01)=axcx(i)*fss(i,01)+gss(i,01)
      fsp(i,02)=aycy(i)*fss(i,01)+gss(i,02)
      fsp(i,03)=azcz(i)*fss(i,01)+gss(i,03)
      fsp(i,04)=axcx(i)*fss(i,02)+gss(i,02)
      fsp(i,05)=aycy(i)*fss(i,02)+gss(i,04)
      fsp(i,06)=azcz(i)*fss(i,02)+gss(i,05)
      fsp(i,07)=axcx(i)*fss(i,03)+gss(i,03)
      fsp(i,08)=aycy(i)*fss(i,03)+gss(i,05)
      fsp(i,09)=azcz(i)*fss(i,03)+gss(i,06)
      fsp(i,10)=axcx(i)*fss(i,04)+gss(i,04)
      fsp(i,11)=aycy(i)*fss(i,04)+gss(i,07)
      fsp(i,12)=azcz(i)*fss(i,04)+gss(i,08)
      fsp(i,13)=axcx(i)*fss(i,05)+gss(i,05)
      fsp(i,14)=aycy(i)*fss(i,05)+gss(i,08)
      fsp(i,15)=azcz(i)*fss(i,05)+gss(i,09)
      fsp(i,16)=axcx(i)*fss(i,06)+gss(i,06)
      fsp(i,17)=aycy(i)*fss(i,06)+gss(i,09)
      fsp(i,18)=azcz(i)*fss(i,06)+gss(i,10)
      fsp(i,19)=axcx(i)*fss(i,07)+gss(i,07)
      fsp(i,20)=aycy(i)*fss(i,07)+gss(i,11)
      fsp(i,21)=azcz(i)*fss(i,07)+gss(i,12)
      fsp(i,22)=axcx(i)*fss(i,08)+gss(i,08)
      fsp(i,23)=aycy(i)*fss(i,08)+gss(i,12)
      fsp(i,24)=azcz(i)*fss(i,08)+gss(i,13)
      fsp(i,25)=axcx(i)*fss(i,09)+gss(i,09)
      fsp(i,26)=aycy(i)*fss(i,09)+gss(i,13)
      fsp(i,27)=azcz(i)*fss(i,09)+gss(i,14)
      fsp(i,28)=axcx(i)*fss(i,10)+gss(i,10)
      fsp(i,29)=aycy(i)*fss(i,10)+gss(i,14)
 2015 fsp(i,30)=azcz(i)*fss(i,10)+gss(i,15)

      do 2016 i=1,nn
      dsd(i,01)=axcx(i)*dsp(i,01)+fsp(i,01)
      dsd(i,02)=aycy(i)*dsp(i,01)+fsp(i,04)
      dsd(i,03)=azcz(i)*dsp(i,01)+fsp(i,07)
      dsd(i,04)=aycy(i)*dsp(i,02)+fsp(i,05)
      dsd(i,05)=azcz(i)*dsp(i,02)+fsp(i,08)
      dsd(i,06)=azcz(i)*dsp(i,03)+fsp(i,09)
      dsd(i,07)=axcx(i)*dsp(i,04)+fsp(i,04)
      dsd(i,08)=aycy(i)*dsp(i,04)+fsp(i,10)
      dsd(i,09)=azcz(i)*dsp(i,04)+fsp(i,13)
      dsd(i,10)=aycy(i)*dsp(i,05)+fsp(i,11)
      dsd(i,11)=azcz(i)*dsp(i,05)+fsp(i,14)
      dsd(i,12)=azcz(i)*dsp(i,06)+fsp(i,15)
      dsd(i,13)=axcx(i)*dsp(i,07)+fsp(i,07)
      dsd(i,14)=aycy(i)*dsp(i,07)+fsp(i,13)
      dsd(i,15)=azcz(i)*dsp(i,07)+fsp(i,16)
      dsd(i,16)=aycy(i)*dsp(i,08)+fsp(i,14)
      dsd(i,17)=azcz(i)*dsp(i,08)+fsp(i,17)
      dsd(i,18)=azcz(i)*dsp(i,09)+fsp(i,18)
      dsd(i,19)=axcx(i)*dsp(i,10)+fsp(i,10)
      dsd(i,20)=aycy(i)*dsp(i,10)+fsp(i,19)
      dsd(i,21)=azcz(i)*dsp(i,10)+fsp(i,22)
      dsd(i,22)=aycy(i)*dsp(i,11)+fsp(i,20)
      dsd(i,23)=azcz(i)*dsp(i,11)+fsp(i,23)
      dsd(i,24)=azcz(i)*dsp(i,12)+fsp(i,24)
      dsd(i,25)=axcx(i)*dsp(i,13)+fsp(i,13)
      dsd(i,26)=aycy(i)*dsp(i,13)+fsp(i,22)
      dsd(i,27)=azcz(i)*dsp(i,13)+fsp(i,25)
      dsd(i,28)=aycy(i)*dsp(i,14)+fsp(i,23)
      dsd(i,29)=azcz(i)*dsp(i,14)+fsp(i,26)
      dsd(i,30)=azcz(i)*dsp(i,15)+fsp(i,27)
      dsd(i,31)=axcx(i)*dsp(i,16)+fsp(i,16)
      dsd(i,32)=aycy(i)*dsp(i,16)+fsp(i,25)
      dsd(i,33)=azcz(i)*dsp(i,16)+fsp(i,28)
      dsd(i,34)=aycy(i)*dsp(i,17)+fsp(i,26)
      dsd(i,35)=azcz(i)*dsp(i,17)+fsp(i,29)
 2016 dsd(i,36)=azcz(i)*dsp(i,18)+fsp(i,30)

      do 2017 j=1,10
      do 2017 i=1,nn
 2017 gather(i,j)=zero

      do 2018 j=1,6
      do 2018 i=1,nn
 2018 gather(i,1)=gather(i,1)+dmat(inddyy(iicontr(i),j))*dss(i,j)

      do 2019 k=1,3
      do 2019 j=1,6
      do 2019 i=1,nn
 2019 gather(i,k+1)=gather(i,k+1)
     &             +dmat(inddyy(iicontr(i),j))*dsp(i,3*(j-1)+k)

      do 2020 k=1,6
      do 2020 j=1,6
      do 2020 i=1,nn
 2020 gather(i,k+4)=gather(i,k+4)
     &             +dmat(inddyy(iicontr(i),j))*dsd(i,6*(j-1)+k)

      do 2021 i=1,nn
      gather(i,01)=gather(i,01)*xcfits
      gather(i,02)=gather(i,02)*xcfitp(1)
      gather(i,03)=gather(i,03)*xcfitp(2)
      gather(i,04)=gather(i,04)*xcfitp(3)
      gather(i,05)=gather(i,05)*xcfitd(1)
      gather(i,06)=gather(i,06)*xcfitd(2)
      gather(i,07)=gather(i,07)*xcfitd(3)
      gather(i,08)=gather(i,08)*xcfitd(4)
      gather(i,09)=gather(i,09)*xcfitd(5)
 2021 gather(i,10)=gather(i,10)*xcfitd(6)

      nc=nxcs+(naux-1)*10

      do 2022 i=1,nn
      do 2022 j=1,10
 2022 vvector(nc+j)=vvector(nc+j)+gather(i,j)

 2001 continue

      return
      end
