      subroutine xvecss(m,n,nxcs,nxcspd,ilfunc,icfunc,icontr,iicontr,
     &                  inddyy,iloc,coord,dmat,vvector,alphaaux,
     &                  coeffs,coeffp,coeffd,zeta,ax,ay,az,px,py,pz,
     &                  base,zetarec,zetafac,efac,gxax,gyay,gzaz,sss,
     &                  ssscond,pss,psscond,dss,dsscond,ssp,psp,ssd,c,
     &                  zzeta,aax,aay,aaz,ppx,ppy,ppz,axcx,aycy,azcz,
     &                  gather)

c  this subroutine written by alain st-amant of the
c  department of chemistry, university of ottawa, ottawa, canada.
c  all rights reserved.  this is part of the DeFT project.

      implicit real*8(a-h,o-z)

      dimension xcfitp(3),xcfitd(6)

      dimension ilfunc(*),icfunc(*),icontr(*),iicontr(*),inddyy(*),
     &          iloc(*)

      dimension coord(3,*),dmat(*),vvector(*),alphaaux(*),coeffs(*),
     &          coeffp(*),coeffd(*),zeta(*),ax(*),ay(*),az(*),px(*),
     &          py(*),pz(*),base(*),zetarec(*),zetafac(*),efac(*),
     &          gxax(*),gyay(*),gzaz(*),sss(*),ssscond(*),pss(n,*),
     &          psscond(n,*),dss(n,*),dsscond(n,*),ssp(n,*),psp(n,*),
     &          ssd(n,*),c(*),zzeta(*),aax(*),aay(*),aaz(*),ppx(*),
     &          ppy(*),ppz(*),axcx(*),aycy(*),azcz(*),gather(n,*)

      data zero,one,two,three/0.0d0,1.0d0,2.0d0,3.0d0/
      data expcut,calcut,pi/45.0d0,1.0d-16,3.1415926535898d0/

      thrhlf=three/two

      sqrt3=sqrt(three)

      do 1000 i=1,n
 1000 base(i)=base(i)*((pi/zeta(i))**thrhlf)

      do 1001 naux=1,nxcs

      ilaux=ilfunc(naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=coeffs(ilaux)

      do 1002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 1002 zetarec(i)=one/(zeta(i)+zetaux)

      do 1003 i=1,n
      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz
 1003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 1004 i=1,n
      if(efac(i).lt.expcut) then

                 sss(i)=zetafac(i)*base(i)*exp(-efac(i))
                 vvector(naux)=vvector(naux)
     &                        +dmat(inddyy(icontr(i)))*sss(i)*xcfits

                            endif
 1004 continue

 1001 continue

      do 2001 naux=1,nxcspd

      ilaux=ilfunc(nxcs+naux)

      ccx=coord(1,icfunc(ilaux))
      ccy=coord(2,icfunc(ilaux))
      ccz=coord(3,icfunc(ilaux))

      zetaux=alphaaux(ilaux)

      xcfits=coeffs(ilaux)

      xcfitp(1)=coeffp(ilaux)
      xcfitp(2)=coeffp(ilaux)
      xcfitp(3)=coeffp(ilaux)

      xcfitd(1)=coeffd(ilaux)/sqrt3
      xcfitd(2)=coeffd(ilaux)
      xcfitd(3)=coeffd(ilaux)
      xcfitd(4)=coeffd(ilaux)/sqrt3
      xcfitd(5)=coeffd(ilaux)
      xcfitd(6)=coeffd(ilaux)/sqrt3

      do 2002 i=1,n
      zetafac(i)=(zeta(i)/(zeta(i)+zetaux))**(three/two)
 2002 zetarec(i)=one/(zeta(i)+zetaux)

      do 2003 i=1,n

      pxcx=px(i)-ccx
      pycy=py(i)-ccy
      pzcz=pz(i)-ccz

 2003 efac(i)=zetaux*zeta(i)*zetarec(i)*(pxcx*pxcx+pycy*pycy+pzcz*pzcz)

      do 2004 i=1,n
      sss(i)=zero
 2004 if(efac(i).lt.expcut) sss(i)=zetafac(i)*base(i)*exp(-efac(i))

      nn=0

      do 2005 i=1,n
      if(abs(sss(i)).gt.calcut) then
                                      nn=nn+1

                                      iloc(nn)=i

                                      iicontr(nn)=icontr(i)

                                      zzeta(nn)=zeta(i)

                                      zetarec(nn)=zetarec(i)

                                      aax(nn)=ax(i)
                                      aay(nn)=ay(i)
                                      aaz(nn)=az(i)

                                      axcx(nn)=ax(i)-ccx
                                      aycy(nn)=ay(i)-ccy
                                      azcz(nn)=az(i)-ccz

                                      ppx(nn)=px(i)
                                      ppy(nn)=py(i)
                                      ppz(nn)=pz(i)

                                      sss(nn)=sss(i)
                                endif
 2005 continue

      do 2006 i=1,nn
      gxax(i)=(zzeta(i)*ppx(i)+zetaux*ccx)*zetarec(i)-aax(i)
      gyay(i)=(zzeta(i)*ppy(i)+zetaux*ccy)*zetarec(i)-aay(i)
 2006 gzaz(i)=(zzeta(i)*ppz(i)+zetaux*ccz)*zetarec(i)-aaz(i)

      do 2007 i=1,nn
 2007 zetarec(i)=zetarec(i)/two

      do 2008 i=1,nn
      pss(i,1)=gxax(i)*sss(i)
      pss(i,2)=gyay(i)*sss(i)
 2008 pss(i,3)=gzaz(i)*sss(i)

      do 2009 i=1,nn

      c(i)=zetarec(i)*sss(i)

      dss(i,1)=gxax(i)*pss(i,1)+c(i)
      dss(i,2)=gyay(i)*pss(i,1)
      dss(i,3)=gzaz(i)*pss(i,1)
      dss(i,4)=gyay(i)*pss(i,2)+c(i)
      dss(i,5)=gzaz(i)*pss(i,2)
      dss(i,6)=gzaz(i)*pss(i,3)+c(i)

 2009 continue

      do 2010 i=1,nn
      ssp(i,1)=axcx(i)*sss(i)+pss(i,1)
      ssp(i,2)=aycy(i)*sss(i)+pss(i,2)
 2010 ssp(i,3)=azcz(i)*sss(i)+pss(i,3)

      do 2011 i=1,nn
      psp(i,1)=axcx(i)*pss(i,1)+dss(i,1)
      psp(i,2)=aycy(i)*pss(i,1)+dss(i,2)
      psp(i,3)=azcz(i)*pss(i,1)+dss(i,3)
      psp(i,4)=axcx(i)*pss(i,2)+dss(i,2)
      psp(i,5)=aycy(i)*pss(i,2)+dss(i,4)
      psp(i,6)=azcz(i)*pss(i,2)+dss(i,5)
      psp(i,7)=axcx(i)*pss(i,3)+dss(i,3)
      psp(i,8)=aycy(i)*pss(i,3)+dss(i,5)
 2011 psp(i,9)=azcz(i)*pss(i,3)+dss(i,6)

      do 2012 i=1,nn
      ssd(i,1)=axcx(i)*ssp(i,1)+psp(i,1)
      ssd(i,2)=aycy(i)*ssp(i,1)+psp(i,4)
      ssd(i,3)=azcz(i)*ssp(i,1)+psp(i,7)
      ssd(i,4)=aycy(i)*ssp(i,2)+psp(i,5)
      ssd(i,5)=azcz(i)*ssp(i,2)+psp(i,8)
 2012 ssd(i,6)=azcz(i)*ssp(i,3)+psp(i,9)

      do 2013 i=1,nn
      gather(i,01)=dmat(inddyy(iicontr(i)))*sss(i)*xcfits
      gather(i,02)=dmat(inddyy(iicontr(i)))*ssp(i,1)*xcfitp(1)
      gather(i,03)=dmat(inddyy(iicontr(i)))*ssp(i,2)*xcfitp(2)
      gather(i,04)=dmat(inddyy(iicontr(i)))*ssp(i,3)*xcfitp(3)
      gather(i,05)=dmat(inddyy(iicontr(i)))*ssd(i,1)*xcfitd(1)
      gather(i,06)=dmat(inddyy(iicontr(i)))*ssd(i,2)*xcfitd(2)
      gather(i,07)=dmat(inddyy(iicontr(i)))*ssd(i,3)*xcfitd(3)
      gather(i,08)=dmat(inddyy(iicontr(i)))*ssd(i,4)*xcfitd(4)
      gather(i,09)=dmat(inddyy(iicontr(i)))*ssd(i,5)*xcfitd(5)
 2013 gather(i,10)=dmat(inddyy(iicontr(i)))*ssd(i,6)*xcfitd(6)

      nc=nxcs+(naux-1)*10

      do 2014 i=1,nn
      do 2014 j=1,10
 2014 vvector(nc+j)=vvector(nc+j)+gather(i,j)

 2001 continue

      return
      end
